
Smart Proxy - Bug #8946

Exception thrown when foreman-proxy restarts with SIGTERM

01/14/2015 04:30 AM - cristian falcas

Status: Closed   

Priority: Normal   

Assignee:    

Category: Core   

Target version: 1.11.0   

Difficulty:  Fixed in Releases:  

Triaged:  Found in Releases: 1.7.1

Bugzilla link:  Red Hat JIRA:  

Pull request: https://github.com/theforeman/smart-pro

xy/pull/332

  

Description

This is what abrt with rubygem-abrt is sending after restarting foreman-proxy:

backtrace:

:/usr/share/foreman-proxy/lib/smart_proxy.rb:143:in `join': SIGTERM (SignalException)

:    from /usr/share/foreman-proxy/lib/smart_proxy.rb:143:in `launch'

:    from /usr/share/foreman-proxy/bin/smart-proxy:6:in `<main>'

Packages installed:

1. rpm -qa | grep foreman| sort

foreman-1.7.1-1.el7.noarch

foreman-cli-1.7.1-1.el7.noarch

foreman-compute-1.7.1-1.el7.noarch

foreman-postgresql-1.7.1-1.el7.noarch

foreman-proxy-1.7.1-1.el7.noarch

foreman-selinux-1.7.1-1.el7.noarch

foreman-vmware-1.7.1-1.el7.noarch

ruby193-rubygem-foreman_abrt-0.0.5-1.el7.noarch

ruby193-rubygem-foreman_column_view-0.2.0-1.el7.noarch

ruby193-rubygem-foreman_docker-0.2.0-2.el7.noarch

ruby193-rubygem-foreman_hooks-0.3.7-2.el7.noarch

ruby193-rubygem-foreman_openscap-0.2.0-1.el7.centos.noarch

ruby193-rubygem-foreman-tasks-0.6.10-3.el7.noarch

ruby193-rubygem-foreman_templates-1.4.0-2.el7.noarch

ruby193-rubygem-puppetdb_foreman-0.1.2-1.el7.noarch

rubygem-hammer_cli_foreman-0.1.3-1.el7.noarch

Associated revisions

Revision 616d41a7 - 11/10/2015 04:36 AM - Dmitri Dolguikh 

Fixes #8946: Added a handler for SIGTERM

History

#1 - 01/14/2015 05:00 AM - Lukas Zapletal

- Category set to 101

Can you provide full steps to reproduce? How you enabled ABRT? What was the procedure, step by step?

I assume RHEL7 with 1.7.1. When you upgrade to 1.7.2 does it disappear?

Thanks.

#2 - 01/14/2015 06:58 AM - cristian falcas

I can't seem to find 1.7.2 on the official repos.
The installation was like this:

- install abrt, configure it to send emails on

- install rubygem-abrt

That was all. at each smart proxy restart I receive an email with that exception.

#3 - 07/13/2015 08:51 AM - Byron Miller

- Tracker changed from Bug to Support

- Status changed from New to Feedback

- Assignee set to Byron Miller

Good Morning!

Foreman has been updated to version 1.8.2.  I am able to use the ABRT plugin on CentOS 6 & 7.1 without having this issue. Are you still

experiencing this issue or have you been able to patch up and see if it works as expected?

Thanks,

#4 - 07/14/2015 06:17 AM - cristian falcas

I still receive the same crash report:

time:           Tue 14 Jul 2015 06:15:43 AM EDT

cmdline:        ruby /usr/share/foreman-proxy/bin/smart-proxy

uid:            994 (foreman-proxy)

abrt_version:   2.1.11

executable:     /usr/share/foreman-proxy/bin/smart-proxy

hostname:       v-so-repo-04.company.net

kernel:         3.10.0-229.7.2.el7.x86_64

last_occurrence: 1436868943

pid:            16243

pkg_arch:       noarch

pkg_epoch:      0

pkg_name:       foreman-proxy

pkg_release:    2.el7

pkg_version:    1.8.2

runlevel:       N 3

username:       foreman-proxy

backtrace:

:/usr/share/foreman-proxy/lib/smart_proxy.rb:144:in `join': SIGTERM (SignalException)

:    from /usr/share/foreman-proxy/lib/smart_proxy.rb:144:in `launch'

:    from /usr/share/foreman-proxy/bin/smart-proxy:6:in `<main>'

Packages installed:

[root@v-so-repo-04 abrt]# rpm -qa | grep foreman | sort

foreman-debug-1.8.2-1.el7.noarch

foreman-proxy-1.8.2-2.el7.noarch

#5 - 07/14/2015 06:31 AM - Dominic Cleal

- Tracker changed from Support to Bug

- Subject changed from foreman smart proxy throws exception  on restart to Exception thrown when foreman-proxy restarts with SIGTERM

- Category changed from 101 to Core

- Status changed from Feedback to New

- Assignee deleted (Byron Miller)

The report makes sense to me, as when the proxy receives a SIGTERM (during service foreman-proxy restart, which is triggered by logrotate) then it

lets the exception bubble up in order for the process to quit.

Since ABRT hooks into Ruby, it's probably just picking that up and registering it as a crash.  An exception handler could be added for SIGTERM

instead.

#6 - 10/20/2015 09:45 AM - Anonymous

change introduced in 335a1610 (https://github.com/theforeman/smart-proxy/commit/335a1610fae8cd74720e2d9841d904deb8ff1881) should fix this.

I'm seeing that smart-proxy exits with 143 status after it's been sent SIGTERM.

#7 - 10/20/2015 10:06 AM - Dominic Cleal
It looks like the handler originally came from #11098, which is also a 1.10.0 change.  The thing is that both handlers re-raise the exception, so I'm

unsure if it'll help with ABRT picking up the exception - it'll need retesting I think.

#8 - 10/23/2015 10:34 AM - Sher Chowdhury

Ok I just built a new foreman 1.10.0 on Centos 7.1.

[vagrant@puppetmaster Desktop]$ sudo -i

ABRT has detected 1 problem(s). For more info run: abrt-cli list

abrt-cli list

id 008dd6d67896ba3a3a940e0cf1937db45746c1b3

reason:         /usr/share/rubygems/rubygems/core_ext/kernel_require.rb:55:in `require': Could not autoload pu

ppet/indirector/report/processor: SIGTERM (Puppet::Error)

time:           Fri 23 Oct 2015 15:34:47 BST

cmdline:        /usr/bin/ruby /usr/bin/puppet agent --no-daemonize

package:        puppet-3.8.3-1.el7

uid:            0 (root)

count:          1

Directory:      /var/spool/abrt/rbhook-2015-10-23-15:34:47-15923

The Autoreporting feature is disabled. Please consider enabling it by issuing

'abrt-auto-reporting enabled' as a user with root privileges

gem list

*** LOCAL GEMS ***

abrt (0.0.6)

ansi (1.4.3)

apipie-bindings (0.0.14)

awesome_print (1.0.2)

bigdecimal (1.2.0)

bundler (1.10.6, 1.3.1)

bundler_ext (0.3.0)

clamp (1.0.0)

colored (1.2)

cri (2.6.1)

faraday (0.9.2)

faraday_middleware (0.9.2)

faraday_middleware-multi_json (0.0.6)

ffi (1.9.3)

gssapi (1.1.2)

hashie (2.0.5)

highline (1.6.21)

io-console (0.4.2)

json (1.7.7)

kafo (0.6.12)

kafo_parsers (0.0.5)

little-plugger (1.1.3)

log4r (1.1.10)

logging (1.8.2)

mime-types (1.19)

minitar (0.5.4)

multi_json (1.10.1)

multipart-post (2.0.0)

net-http-persistent (2.8)

netrc (0.7.7)

oauth (0.4.7)

passenger (4.0.18)

powerbar (1.0.11)

psych (2.0.0)

r10k (2.0.3)

rack (1.5.2)

rack-protection (1.3.2)

rake (10.4.2, 0.9.6)

rdoc (4.0.0)

rest-client (1.6.7)

rkerberos (0.1.3)

rubyipmi (0.10.0)

semantic_puppet (0.1.1)

sinatra (1.3.5)

thor (0.17.0)

tilt (1.3.7)

You have mail in /var/spool/mail/root

[root@puppetmaster ~]# facter -p
architecture => x86_64

augeasversion => 1.1.0

bios_release_date => 12/01/2006

bios_vendor => innotek GmbH

bios_version => VirtualBox

blockdevice_sda_model => VBOX HARDDISK

blockdevice_sda_size => 41943040000

blockdevice_sda_vendor => ATA

blockdevices => sda

boardmanufacturer => Oracle Corporation

boardproductname => VirtualBox

boardserialnumber => 0

dhcp_servers => {"system"=>"10.0.2.2", "enp0s3"=>"10.0.2.2"}

domain => local

facterversion => 2.4.4

filesystems => iso9660,xfs

fqdn => puppetmaster.local

gid => root

hardwareisa => x86_64

hardwaremodel => x86_64

hostname => puppetmaster

id => root

interfaces => enp0s3,enp0s8,lo

ipaddress => 10.0.2.15

ipaddress_enp0s3 => 10.0.2.15

ipaddress_lo => 127.0.0.1

is_virtual => true

kernel => Linux

kernelmajversion => 3.10

kernelrelease => 3.10.0-229.14.1.el7.x86_64

kernelversion => 3.10.0

macaddress => 08:00:27:60:20:81

macaddress_enp0s3 => 08:00:27:60:20:81

macaddress_enp0s8 => 08:00:27:7b:9d:4c

manufacturer => innotek GmbH

memoryfree => 317.06 MB

memoryfree_mb => 317.06

memorysize => 993.52 MB

memorysize_mb => 993.52

mtu_enp0s3 => 1500

mtu_enp0s8 => 1500

mtu_lo => 65536

netmask => 255.255.255.0

netmask_enp0s3 => 255.255.255.0

netmask_lo => 255.0.0.0

network_enp0s3 => 10.0.2.0

network_lo => 127.0.0.0

operatingsystem => CentOS

operatingsystemmajrelease => 7

operatingsystemrelease => 7.1.1503

os => {"name"=>"CentOS", "family"=>"RedHat", "release"=>{"major"=>"7", "minor"=>"1", "full"=>"7.1.1503"}}

osfamily => RedHat

partitions => {"sda1"=>{"uuid"=>"9dac9928-7542-4a76-bae5-d02a5b493f17", "size"=>"1024000", "mount"=>"/boot", "

filesystem"=>"xfs"}, "sda2"=>{"size"=>"80893952", "filesystem"=>"LVM2_member"}}

path => /usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/usr/local/bin:/root/bin:/sbin

physicalprocessorcount => 1

processor0 => Intel(R) Core(TM) i7 CPU       M 620  @ 2.67GHz

processor1 => Intel(R) Core(TM) i7 CPU       M 620  @ 2.67GHz

processorcount => 2

processors => {"models"=>["Intel(R) Core(TM) i7 CPU       M 620  @ 2.67GHz", "Intel(R) Core(TM) i7 CPU       M

 620  @ 2.67GHz"], "count"=>2, "physicalcount"=>1}

productname => VirtualBox

ps => ps -ef

puppetversion => 3.8.3

rubyplatform => x86_64-linux

rubysitedir => /usr/local/share/ruby/site_ruby/

rubyversion => 2.0.0

selinux => true

selinux_config_mode => permissive

selinux_config_policy => targeted

selinux_current_mode => permissive

selinux_enforced => false

selinux_policyversion => 28

serialnumber => 0

sshecdsakey => AAAAE2VjZHNhLXNoYTItbmlzdHAyNTYAAAAIbmlzdHAyNTYAAABBBLvUCR0cHrjKJvegObFEBctUOSWbiOC7kmcIhAZq0bj
QVbO25pbbqwA1R73/JGWsTau0VKb0m9yaq4dV5z9MI70=

sshed25519key => AAAAC3NzaC1lZDI1NTE5AAAAIJUWez+MxJyNzJlsHxCHXqlrO1eamzEVslnGyXsBV0XE

sshfp_ecdsa => SSHFP 3 1 49da5c639715666b95cf587c93f6a67754963326

SSHFP 3 2 7bbac5d1d16f00bbbb31f4a7ad7d7034bd162a94125e779fb518ed4e504da8c1

sshfp_ed25519 => SSHFP 4 1 36ddbddeb7d8606df5c46eef747d8978630383b0

SSHFP 4 2 056fb735e786873175cbd6eb1f27aea85f864c32742c3fb440efe4b72711c034

sshfp_rsa => SSHFP 1 1 3931bc434b636c699c0bc79806061502c62f08c8

SSHFP 1 2 8af64d3d355c10aa1a3481f67979e5a2a612915c395baccbf52e063dc4a66fc3

sshrsakey => AAAAB3NzaC1yc2EAAAADAQABAAABAQCXeG4+HexB5kHP3ThDehI44Hn2C3wG6hECAs/q8e5OEdCvGYrOsAiR+0Wf7n5QUYpdi

jftSGRnI8JAOjNba93lyDvrKb1KnIP8OEPV8Dw1SUJ7pAQ45iShPBcQs4ZCXsO+ixlqaJmpFaf5jDkg2+4r0uVDybOZ6lkCU2gCHGehrEjojwT

mqeGJ+QAgZNUkrjjLqgl5k3W+SZAa6G4VFHdRdvIvzXm3s+LnQSDZ4bmpwsZ82oizwGlHnohQ3/wcNMg4PgmXWGBI/91K2aJnFpxxd85wKRIhO

Po8emNtE0dvjsb5T+Wm8UJXpvn43t+YER8hcb9bfMlRU9MZ1j33VNwz

swapfree => 860.21 MB

swapfree_mb => 860.21

swapsize => 1024.00 MB

swapsize_mb => 1024.00

system_uptime => {"seconds"=>1582, "hours"=>0, "days"=>0, "uptime"=>"0:26 hours"}

timezone => BST

type => Other

uniqueid => 007f0101

uptime => 0:26 hours

uptime_days => 0

uptime_hours => 0

uptime_seconds => 1582

uuid => 782E535D-4293-4A27-AC32-DE94AE12213C

virtual => virtualbox

[root@puppetmaster ~]# rpm -qa | grep foreman | sort

foreman-1.10.0-0.1.RC1.el7.noarch

foreman-cli-1.10.0-0.1.RC1.el7.noarch

foreman-debug-1.10.0-0.1.RC1.el7.noarch

foreman-installer-1.10.0-0.1.RC1.el7.noarch

foreman-postgresql-1.10.0-0.1.RC1.el7.noarch

foreman-proxy-1.10.0-0.1.RC1.el7.noarch

foreman-release-1.10.0-0.1.RC1.el7.noarch

foreman-release-scl-1-1.el7.x86_64

foreman-selinux-1.10.0-0.1.RC1.el7.noarch

tfm-rubygem-foreman_setup-3.0.2-1.fm1_10.el7.noarch

tfm-rubygem-hammer_cli_foreman-0.4.0-1.el7.noarch

#9 - 10/23/2015 10:36 AM - Dominic Cleal

I don't think that's related, it's a completely different process reporting an error - it's the Puppet agent, not the smart proxy.

The interesting thing will be to see if your 1.10.0-RC1 system logs a further ABRT notice when logrotation of foreman-proxy occurs.

#10 - 10/23/2015 10:38 AM - Sher Chowdhury

After rebooting my foreman vm, I then get the following error messages:

login as: root

root@192.168.50.10's password:

ABRT has detected 2 problem(s). For more info run: abrt-cli list --since 1445610273

[root@puppetmaster ~]# abrt-cli list --since 1445610273

id 9af525842c3a277d36c430a4f82b84bbc8ad42ef

reason:         /usr/share/foreman-proxy/lib/launcher.rb:128:in `join': SIGTERM (SignalException)

time:           Fri 23 Oct 2015 15:35:08 BST

cmdline:        ruby /usr/share/foreman-proxy/bin/smart-proxy

package:        foreman-proxy-1.10.0-0.1.RC1.el7

uid:            992 (foreman-proxy)

count:          1

Directory:      /var/spool/abrt/rbhook-2015-10-23-15:35:08-2267

id 008dd6d67896ba3a3a940e0cf1937db45746c1b3

reason:         /usr/share/rubygems/rubygems/core_ext/kernel_require.rb:55:in `require': Could not autoload pu

ppet/indirector/report/processor: SIGTERM (Puppet::Error)

time:           Fri 23 Oct 2015 15:34:47 BST

cmdline:        /usr/bin/ruby /usr/bin/puppet agent --no-daemonize

package:        puppet-3.8.3-1.el7

uid:            0 (root)

count:          1

Directory:      /var/spool/abrt/rbhook-2015-10-23-15:34:47-15923

The Autoreporting feature is disabled. Please consider enabling it by issuing

'abrt-auto-reporting enabled' as a user with root privileges
#11 - 10/23/2015 10:40 AM - Dominic Cleal

That looks like it's still there then, thanks for confirming.  I'd guess it's also happening during service stop (on shutdown) as well as restart (on

logrotate).

#12 - 10/28/2015 10:12 AM - The Foreman Bot

- Status changed from New to Ready For Testing

- Pull request https://github.com/theforeman/smart-proxy/pull/332 added

- Pull request deleted ()

#13 - 11/09/2015 07:20 AM - The Foreman Bot

- Assignee set to Anonymous

#14 - 11/10/2015 04:38 AM - Dominic Cleal

- translation missing: en.field_release set to 71

#15 - 11/10/2015 05:01 AM - Anonymous

- Status changed from Ready For Testing to Closed

- % Done changed from 0 to 100

Applied in changeset 616d41a7841009a632e65f0b6360bdeec58df260.
